#include "asm86.h"
#include "ti86asm.inc"

.org $D748

alku:
    jp zappoz
zappoz:
    ld (saveix),ix
    di
    call inter
    ld ix,start
jumphere:
;    ld (saveiy),iy
    ld (savesp),sp
    ld sp,stack
EditMode:


    ld b,0
foo2:
    in a,(3)
    and 8
    jr z,EditMode
    djnz foo2

    ld a,$0A
    out (3),a
    ld a,$0B
    out (3),a


    ld a,$2C
    out (0),a
    xor a
    ld (cmd),a
alaku:
_cmd:
    ld a,0
    and a
    jr nz,quick

    ld a,$E5
    ld (myputc),a

    call clear

    push ix
    ld b,13
    ld hl,dmem+8
uusix:
    push bc
    call disasm
    ld de,16*5
    add hl,de
    pop bc
    djnz uusix
    pop ix
    call showall

    call mygetkey

    ld a,$C9
    ld (myputc),a

quick:
    ld a,1
    ld (ln),a
    ld a,$C3
    ld (flgs),a
    push ix
    call disasm
    pop hl

    ld a,h
    cp $0D
    jr nz,noROM
    ld a,l
    cp $BE          ; some nasty memory locations that try to remove
    jr nz,nobe      ; my user interrupt during mem reset...
    push af         ; so we emulate the whole start-up process and ensure
    ld a,4          ; that no one messes with my interrupts!
    ld (saveaf+1),a
    pop af
nobe:
    cp $CE
    jr z,alaku
    cp $D2
    jp z,forcequit
noROM:



_warn:
    ld a,0
    and a
    jr z,nospecial
    ld b,a
    ld a,(saveaf)
    ld e,a
    push de
    pop af
    ld a,b
flgs:                   ; jp is self-modified to, for example, jp c or jp m
    jp special
nospecial:

    ld de,0
    ld (area),de
    ld (area+2),de

    ld b,d
    ld de,area
_ln:
    ld c,0
    ldir






exec:                   ; heart of the program, "emulation" core
    ld sp,saveaf        ; simple eh?
    pop af
    pop bc
    pop de
    pop hl
    ex (sp),ix
    ld sp,(savesp)
area:
    nop
    nop
    nop
    nop
    ld (savesp),sp
    ld sp,saveix
    ex (sp),ix
    push hl
    push de
    push bc
    push af
    ld sp,stack







    in a,(3)
    and 8
    jp nz,alaku

    jp EditMode

nxt:
    inc ix
    push hl
    ld hl,ln
    inc (hl)
    pop hl
start:
    ret
    xor a
debuggah:
    neg
    neg
    inc a
    jr debuggah
    ret
;    rlc a
;    rlc (hl)
;    rlc (ix+2)
;    .db $FD,$CB,$2,$4
;    bit 5,a
;    bit 5,(hl)
;    bit 5,(iy-2)
;    .db $DD,$CB,-2,$6C

colon:
    ld a,45
    ld c,1
    jp myputc
space:
    ld a,36
    ld c,1
    jp myputc

.dw 0,0,0,0
.dw 0,0,0,0,0,0,0,0,0,0,0,0 ; at least this is enough...
stack:
savesp:
    .dw 0
saveaf:
    .dw 1
savebc:
    .dw 2
savede:
    .dw 3
savehl:
    .dw 4
saveix:
    .dw 5
address:
    .dw 0

#include show.asm

special:          ; nasty instructions have to be emulated
    dec a
    jr z,ecall
    dec a
    jr z,ejump
    dec a
    jr z,eret
    dec a
    jr z,edjnz
    jp alaku      ; ei (GET RID OF IT!!!)
eret:
    ld sp,(savesp)
    pop ix
    ld (savesp),sp
    ld sp,stack
    jp alaku
ecall:
    ld sp,(savesp)
    push ix
    ld (savesp),sp
    ld sp,stack
ejump:
    ld ix,(address)
    jp alaku
edjnz:
    ld hl,savebc+1
    dec (hl)
    jp z,alaku
    ld ix,(address)
    jp alaku

disasm:
#include disasm.asm
    ret

mygetkey:
    ld a,%00111111 ; check if exit was pressed




    out (1),a
    in a,(1)


    bit 4,a
    jr nz,noc
    ld a,$3C
    out (0),a
    ld (cmd),a
    jp w2
noc:


    bit 6,a
    jr nz,noquit
quit:
    call check
forcequit:
    ld a,$3C
    out (0),a
    ld a,$C3
    ld (area),a
    ld (area+1),ix
    call w2
    jp exec

noquit:


    bit 7,a
    jr nz,noskip

    ld a,1
    ld (ln),a
    ld a,$C3
    ld (flgs),a
    call disasm
    pop hl
    call w2

    jp alaku
noskip:

    bit 3,a
    jr nz,nonocall
    call cal
    call w2
    pop hl
    jp alaku
nonocall:

    bit 2,a
    jr nz,nopeek
    ld a,$3C
    out (0),a
    call w2
    ld a,$2C
    out (0),a
    jr mygetkey
nopeek:

    bit 1,a
    jp nz,nohex
#include hexed.asm
nohex:

    bit 0,a
    jp nz,nowipe

    call check

    ld hl,$4000
    ld de,$4001
    ld a,64+1
    ld b,3
clrloop:
    push bc
    ld bc,$D747-$4000

    out (5),a
    inc a
    out (6),a
    inc a
    ld (hl),0
    push hl
    push de
    ldir
    pop de
    pop hl
    pop bc
    djnz clrloop

    out (5),a
    ld (hl),0
    ld bc,$D747-$4000
    ldir

    ld hl,loppuh
    ld de,loppuh+1
    ld (hl),0
    ld bc,loppuh
    ld a,b
    cpl
    ld b,a
    ld a,c
    cpl
    ld c,a
    ldir
    xor a
    out (5),a

    call inter

    ld sp,saveix+2

    ld hl,0
    push hl ; ix
    dec hl
    push hl ; hl
    inc hl
    push hl ; de
    push hl ; bc
    push hl ; af
    ld iy,$C3E5
    ld hl,$FBFC
    push hl ; sp

    ld ix,$0D33
    ld sp,stack
    jp alaku

nowipe:

    bit 5,a
    jp nz,mygetkey
w2:
    ld a,%00000001 ; check if exit was pressed
    out (1),a
    in a,(1)
    inc a
    jr nz,w2
    ret


#include mon.h
#include tables.asm

cmd EQU _cmd+1
warn EQU _warn+1
ln EQU _ln+1

inter:
#include inter.asm

#include cal.asm

loppuh:
;.db 96,"abcdefghijklmnopqrstuvwxyz",123
;.db 47,"0123456789",58
;.db 64,"ABCDEFGHIJKLMNOPQRSTUVWXYZ",91
;.db "()$"
.end
