; a:  instruction
; de: parameters
; hl: video mem address
disp:
    push de
    push hl
    ld hl,warn
    ld (hl),0
    cp 58      ; rst
    jr nz,kjp
    ld (hl),1   ; warn about upcoming call instruction
kjp:
    cp 4        ; call
    jr nz,jkl
    ld (hl),1   ; warn
jkl:
    cp 27       ; jump
    jr nz,gds
    ld (hl),2
gds:
    cp 28       ; jump
    jr nz,gds2
    ld (hl),2
gds2:
    cp 45       ; ret
    jr nz,afffe
    ld (hl),3
afffe:
    cp 46       ; reti
    jr nz,afffe2
    ld (hl),3
afffe2:
    cp 47       ; retn
    jr nz,afffe3
    ld (hl),3
afffe3:
    cp 15       ; djnz
    jr nz,wsfsd
    ld (hl),4
wsfsd:
    cp 16       ; ei
    jr nz,noei
    ld (hl),5
noei:
    cp 19       ; halt
    jr nz,nohalt
    ld (hl),1   ; you want interrupts? Then have them!
    ld hl,$38
    ld (address),hl
nohalt:
;    cp 33       ; ldir (dangerous when using memory protection)
;    jr nz,noldir
;    ld (hl),6
;noldir:
    rlca
    ld hl,ins
    ld d,0
    ld e,a
    add hl,de
    add hl,de
    ex de,hl
    pop hl
    ld c,4
    xor a
    ld (xcoord),a
    call myputs

;    ld c,1
    inc c
    ld a,36
    call myputc
    pop de
    ld a,d
    cp 66
;    jr z,exit
    ret z
    push de
    call showparm
    pop de
    ld a,e
    cp 66
;    jr z,exit
    ret z

    ld c,1
    ld a,39
;    push de
    call myputc
;    pop de
    ld a,e
;    call showparm
;exit:
;    ret

showparm:
    cp 6
    jr z,flipit
    ld d,a
    and %11110110
    cp  %00000100
    ld a,d
    jr nz,noflip
flipit:
    push hl
    ld hl,mode+1
    ld d,(hl)
    dec d
    pop hl

    jr z,nomdix
    add a,d
;    cp 21
;    jr nz,noflip
;    ld b,48
;    push bc
;    jr pheer
nomdix:
noflip:
    cp bgrst
    jp nc,notlisted

    push af
    sub bgrst-8
    jr c,gotflag
    rlca
    rlca
    rlca
    add a,$C2
    ld (flgs),a
gotflag:
    pop af

    push af
pheer:
    rlca
    ld de,poffset
    add a,e
    ld e,a
    adc a,d
    sub e
    ld d,a
    ld a,(de)
    ld c,a          ; length
    inc de
    ld a,(de)
    ld de,params
    add a,e
    ld e,a
    adc a,d
    sub e
    ld d,a

    call myputs
    pop af
    cp c8b
    jr nz,no8b

;    inc ix
    call nxt
    ld a,(ix)
    jp showhex
no8b:
    cp c16b
    jr nz,no16b

;    inc ix
    call nxt
    ld a,(ix+1)
    ld (address+1),a
    call showhex
;    inc ix
    call nxt
    ld a,(ix-1)
    ld (address),a
    jp showhex
no16b:
    cp ci16b
    jr nz,noi16b

;    inc ix
    call nxt
    ld a,(ix+1)
    call showhex
;    inc ix
    call nxt
    ld a,(ix-1)
    call showhex
    ld a,38
    ld c,1
    jp myputc
noi16b:
    cp cp8b
    jr nz,noix16b

;    inc ix
    call nxt
    ld a,(ix)
    inc a
    push ix
    pop bc
    cp 128
    jr c,noneg
    dec b
noneg:
    add a,c
    ld c,a
    adc a,b
    sub c
    ld b,a
    push bc
    ld (address+1),a
    call showhex
    pop bc
    ld a,c
    ld (address),a
    jr showhex
noix16b:
    cp 13
    jr nz,dfdf
    push hl
    ld hl,(savehl)
    ld (address),hl
    pop hl
dfdf:
    cp 25
    jr nz,dfdf2
    push hl
    ld hl,(saveix)
    ld (address),hl
    pop hl
dfdf2:
    cp 28
    jr nz,dfdf3
    ld (address),iy
dfdf3:
    cp 21
    jr z,hrdd
    cp 18
    ret nz
hrdd:
;    inc ix
    call nxt
    ld a,(ix)
    cp 128
    ld c,42
    jr c,noneg2
    ld c,43
    cpl
    inc a
noneg2:
    push af
    ld a,c
    ld c,1
    call myputc
    pop af
    call showhex
    ld a,38
    ld c,1
    jr myputc
notlisted:
    sub 57
    jr c,numb
    ld c,1
    jr myputc
numb:
    add a,9
    rlca
    rlca
    rlca
    ld (address),a
    push af
    xor a
    ld (address+1),a
    pop af

showhex:
    ld de,tmp+1
    ld b,a
    and %00001111
    ld (de),a
    dec de
    ld a,b
    and %11110000
    rrca
    rrca
    rrca
    rrca
    ld (de),a
    ld c,2
;    call myputs

; put string
; input:
; hl: video mem start
; de->string
; c: len
; output:
; hl: hl+c/2
; de->string+c
; bc: 0
myputs:
    ld a,(de)
myputc: ; A holds char
    push hl
    push de
    ld de,$0000
    srl a
    jr c,ohip
    ld de,$0F0F
ohip:
    ld (putssm),de
    ld (putssm+2),de

    rlca
    rlca
    ld de,font
    add a,e
    ld e,a
    adc a,d
    sub e
    ld d,a

    ld b,4
ploop:
    ld a,(de)
putssm:
    nop
    nop
    nop
    nop
    rld
    ld a,16
    add a,l
    ld l,a
    adc a,h
    sub l
    ld h,a
    inc de
    djnz ploop

    pop de
    ld hl,xcoord
    inc (hl)
    ld a,(hl)
    pop hl
    and 1
    jr nz,eisit
    inc hl
eisit:
    dec c
    ret z
    inc de
    jr myputs

clear:
    ld hl,dmem     ; look! not 1 single ROM call in the whole program!
    ld de,dmem+1
    ld (hl),0
    ld bc,1024
    ldir
    ret
