    cp $40              ; regular set #1 ends at $40
    jr nc,SkipGroup1

    and %11110000       ; This code sets registers according to possible
    rrca                ; parameters. If op-code is under $10 then affected
    rrca                ; registers are BC, B or C. If it's under $20 they
    rrca                ; are DE, D and E. for $30 it's HL, H and L and
    ld d,a              ; finally for $40 SP, (HL) and A.
;    rrca                ; If you look at the parameter table below, that's
    add a,8             ; just the way they are ordered there so we only need
                        ; a few operations to calculate the parameters that
    ld c,a              ; are passed to the routine which displays the
;    res 0,d             ; instruction.
    ld e,d
    inc e
                        ; C is 16 bit register, D is high byte, E low byte

    ld a,b
    dec a
    and %00001111       ; High nibble told the register, low nibble tells
                        ; the actual instruction.
    ld hl,G1Table
EDJumpHere:             ; ED group is similar to this, code is common from
    ld b,a              ; this point.
    rlca
    add a,b
    add a,l
    ld l,a
    adc a,h
    sub l
    ld h,a
    ld b,c
    inc b

    ld a,(hl)
    cp 70
    jr c,skipit
    ld (sm1),a
sm1:
    nop
skipit:
    push af
    inc hl

    ld a,(hl)
    cp 70
    jr c,skipit2
    ld (sm2),a
sm2:
    nop
skipit2:
    ld e,a
    pop af
    ld d,a

    inc hl
    ld a,(hl)
    jp Ready



SkipGroup1:
    cp $80 ; regular set #2 ends at $80
    jr nc,SkipGroup2

    and %00111000   ; group 2 is my favorite: just 64 ld instructions with
    rrca            ; 1 halt in the middle. This is the reason why I didn't
    rrca            ; do a simple table lookup =)
    rrca
    ld d,a

    ld a,b
    and %00000111
    ld e,a
    ld a,29

    jr Ready        ; that's it! every possible opcode from $40 to $7F parsed!
SkipGroup2:
    cp $C0 ; regular set #3 ends at $C0
    jr nc,SkipGroup3

    and %00000111
    ld d,a
    ld e,66
    ld a,b
    cp $A0
    jr nc,noaddsub
    ld e,d
    ld d,7
noaddsub:
    and %01111000
    rrca
    rrca
    rrca
    ld hl,G3Table
    add a,l
    ld l,a
    adc a,h
    sub l
    ld h,a
    ld a,(hl)

    jr Ready
SkipGroup3:         ; last and most annoying group (I hate this one)

    and %00111000
    rrca
    rrca
    rrca
    add a,flag
    ld d,a
    ld e,c16b
    ld a,b
    and %00000111

    jr nz,noret
    ld e,66
    ld a,45
    jr Ready
noret:
    dec a
    dec a
    jr nz,nojp
    ld a,27
    jr Ready
nojp:
    dec a
    dec a
    jr nz,nocall
    ld a,4
    jr Ready
nocall:
    dec a
    dec a
    jr nz,noarth
    ld a,b
    sub 6
    ld de,c8b*256+66
    and %00111000
    rrca
    rrca
    rrca
    cp 4
    jr nc,noaddsub2
    ld de,7*256+c8b
noaddsub2:
    ld hl,G3Table
    add a,l
    ld l,a
    adc a,h
    sub l
    ld h,a
    ld a,(hl)
    jr Ready
noarth:             ; it's rst then
    ld a,d
    add a,(bgrst-flag)
    ld d,a
    ld a,58
    ld e,66
    jr Ready
